#include <QApplication>
#include <QDebug>
#include <QtWidgets>

#include <desqwl/DropDownSurface.hpp>

QWidget *getUI() {

	QTextEdit *edit = new QTextEdit();

	QToolButton *close = new QToolButton();
	close->setIcon( QIcon::fromTheme( "application-exit" ) );

	QGridLayout *lyt = new QGridLayout();
	lyt->setContentsMargins( QMargins() );
	lyt->addWidget( edit, 0, 0 );
	lyt->addWidget( close, 0, 0, Qt::AlignRight | Qt::AlignBottom );

	QWidget *ui = new QWidget();
	ui->setLayout( lyt );
	ui->setFixedSize( QSize( 1366, 500 ) );
	ui->move( 0, 0 );

	QObject::connect( close, &QToolButton::clicked, ui, &QWidget::close );

	return ui;
};

int main(int argc, char *argv[]) {

	qputenv( "QT_QPA_PLATFORM", QByteArray( "wayland" ) );
	qputenv( "QT_WAYLAND_SHELL_INTEGRATION", QByteArray( "desq-layershell-plugin" ) );

    QApplication a(argc, argv);

	QWidget *ui = getUI();
	ui->show();

	DesQ::DropDownSurface *surface = DesQ::DropDownSurface::fromQWindow( ui->windowHandle() );
	surface->setSize( 1366, 500 );
	surface->setAnchor( DesQ::DropDownSurface::anchor_top | DesQ::DropDownSurface::anchor_left | DesQ::DropDownSurface::anchor_right );
	surface->setKeyboardInteractivity( true );
	surface->apply();

    return a.exec();
};
