#pragma once

#include <wayland-client.h>

#include <QtWaylandClient/private/qwaylandshellsurface_p.h>
#include <QtWaylandClient/private/qwaylandshellintegration_p.h>
#include <QtWaylandClient/private/qwaylanddisplay_p.h>
#include <QtWaylandClient/private/qwaylandwindow_p.h>

#include <qwayland-wlr-layer-shell-unstable-v1.h>

typedef QtWaylandClient::QWaylandShellSurface QtWaylandShellSurface;
typedef QtWaylandClient::QWaylandDisplay QtWaylandDisplay;
typedef QtWaylandClient::QWaylandWindow QtWaylandWindow;

typedef QtWayland::zwlr_layer_shell_v1 wlrLayerShell;
typedef QtWayland::zwlr_layer_surface_v1 wlrLayerSurface;

namespace DesQ {
    class DropDownShell;
    class DropDownSurface;
};

class DesQ::DropDownShell : public wlrLayerShell {

    public:
        DropDownShell( QtWaylandDisplay *display, wlrLayerShell *shell );
        virtual ~DropDownShell();

        DesQ::DropDownSurface *createLayerSurface( QtWaylandWindow *window );

    private:
        QtWaylandClient::QWaylandDisplay *m_display;
};
