#include <qwayland-wlr-layer-shell-unstable-v1.h>

#include "DropDownSurface.hpp"
#include "DropDownSurfaceImpl.hpp"
#include "DesQShellIntegration.hpp"

DesQ::ShellIntegration::ShellIntegration() {
}

bool DesQ::ShellIntegration::initialize( QtWaylandClient::QWaylandDisplay *display ) {

    QWaylandShellIntegration::initialize( display );
    display->addRegistryListener( registryLayer, this );
    return m_layerShell != nullptr;
}

QtWaylandShellSurface* DesQ::ShellIntegration::createShellSurface( QtWaylandWindow *window ) {

    return m_layerShell->createLayerSurface( window );
}

void DesQ::ShellIntegration::registryLayer( void *data, wl_registry *registry, uint32_t id, const QString &interface, uint32_t version ) {

    DesQ::ShellIntegration *shell = static_cast<DesQ::ShellIntegration *>( data );

    if ( interface == QStringLiteral( "zwlr_layer_shell_v1" ) )
        shell->m_layerShell = new DesQ::DropDownShell( shell->m_display, new QtWayland::zwlr_layer_shell_v1( registry, id, version ) );
}
