TEMPLATE = lib
TARGET = desq-wl

QT += widgets gui-private dbus

INCLUDEPATH += .
DEPENDPATH += .

# Silent compilation
CONFIG += silent -std=c++17

# Link wayland scanner
CONFIG += link_pkgconfig wayland-scanner

# Build Wayland protocols
QMAKE_USE += wayland-client

# WaylandClientSources
WAYLANDCLIENTSOURCES += protocols/wayland.xml
WAYLANDCLIENTSOURCES += protocols/xdg-shell.xml
WAYLANDCLIENTSOURCES += protocols/wayfire-shell-unstable-v2.xml
WAYLANDCLIENTSOURCES += protocols/wlr-layer-shell-unstable-v1.xml
WAYLANDCLIENTSOURCES += protocols/wlr-foreign-toplevel-management-unstable-v1.xml

# Headers
HEADERS += AutoHideWindow.hpp
HEADERS += DesQWlGlobal.hpp
HEADERS += LayerShell.hpp
HEADERS += Registry.hpp
HEADERS += WindowManager.hpp

# Sources
SOURCES += AutoHideWindow.cpp
SOURCES += DesQWlGlobal.cpp
SOURCES += LayerShell.cpp
SOURCES += Registry.cpp
SOURCES += WindowManager.cpp

# Build location
BUILD_PREFIX = $$(DESQ_BUILD_DIR)
isEmpty( BUILD_PREFIX ) {
	BUILD_PREFIX = .build
}

MOC_DIR 	= $$BUILD_PREFIX/libdesqwl/moc
OBJECTS_DIR = $$BUILD_PREFIX/libdesqwl/obj
RCC_DIR		= $$BUILD_PREFIX/libdesqwl/qrc
UI_DIR      = $$BUILD_PREFIX/libdesqwl/uic

unix {
	isEmpty(PREFIX) {
		PREFIX = /usr
	}
	LIBDIR = $$PREFIX/lib/

	INSTALLS += target headers
	target.path = $$LIBDIR

	headers.path = $$PREFIX/include/desqwl
	headers.files = $$HEADERS
}
